-- Author      : admin
-- Create Date : 10/13/2019 2:30:45 PM

do
    local a = newArray();

    local b = a.splice();

    assert(#a == 0, 'expect #a to be 0');
    assert(#b == 0, 'expect #b to be 0');
    assert(b ~= a, 'expect b not to be a');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.splice();

    assert(#a == 9, 'expect #a to be 9');
    assert(#b == 0, 'expect #b to be 0');
    assert(b ~= a, 'expect b not to be a');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.splice(5, 0);

    assert(#a == 9, 'expect #a to be 9');
    assert(#b == 0, 'expect #b to be 0');
    assert(b ~= a, 'expect b not to be a');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.splice(5);

    assert(#a == 4, 'expect #a to be 4');
    assert(#b == 5, 'expect #b to be 5');
    assert(b ~= a, 'expect b not to be a');

    assert(a[1] == 1);
    assert(a[2] == 2);
    assert(a[3] == 3);
    assert(a[4] == 4);
    assert(b[1] == 5);
    assert(b[2] == 6);
    assert(b[3] == 7);
    assert(b[4] == 8);
    assert(b[5] == 9);
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.splice(5);

    assert(#a == 4, 'expect #a to be 4');
    assert(#b == 5, 'expect #b to be 5');
    assert(b ~= a, 'expect b not to be a');

    assert(a[1] == 1);
    assert(a[2] == 2);
    assert(a[3] == 3);
    assert(a[4] == 4);
    assert(b[1] == 5);
    assert(b[2] == 6);
    assert(b[3] == 7);
    assert(b[4] == 8);
    assert(b[5] == 9);
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.splice(5, nil, 10, 11);

    assert(#a == 6, 'expect #a to be 6');
    assert(#b == 5, 'expect #b to be 5');
    assert(b ~= a, 'expect b not to be a');

    assert(a[1] == 1);
    assert(a[2] == 2);
    assert(a[3] == 3);
    assert(a[4] == 4);
    assert(a[5] == 10);
    assert(a[6] == 11);
    assert(b[1] == 5);
    assert(b[2] == 6);
    assert(b[3] == 7);
    assert(b[4] == 8);
    assert(b[5] == 9);
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.splice(5, 2, 15, 16);

    assert(#a == 9, 'expect #a to be 6');
    assert(#b == 2, 'expect #b to be 5');
    assert(b ~= a, 'expect b not to be a');

    assert(a[1] == 1);
    assert(a[2] == 2);
    assert(a[3] == 3);
    assert(a[4] == 4);
    assert(a[5] == 15);
    assert(a[6] == 16);
    assert(a[7] == 7);
    assert(a[8] == 8);
    assert(a[9] == 9);
    assert(b[1] == 5);
    assert(b[2] == 6);
end