-- Author      : admin
-- Create Date : 10/28/2019 10:19:08 AM

local beql = LibStub("AceAddon-3.0"):GetAddon("beql");

--
--- Party Functions
--

function beql:Quixote_Quest_Gained(...)
	local uid = select(2 , ...)
	beql:debugprint('New Quixote Quest: ' .. tostring(uid))
	if (beql.db.char.newquestid == uid) then
		beql:QuestTracker_QuestGained(...)
		if (beql.db.profile.QuestLog.chat.accept) then
			beql:Party_Status2Chat(L['Quest Accepted: '] .. select(1, ...))
		end
	end
end

local AbadonedQuestId = 0

function beql:Quixote_Quest_Lost(name, uid)
	if (AbadonedQuestId == uid) then
		AbadonedQuestId = 0
		return
	end
	if (beql.db.profile.QuestLog.chat.delivert) then
		beql:Party_Status2Chat(L['Quest finalized: '] .. tostring(name))
	end
end

function beql:Quixote_Quest_Abandoned(name, uid)
	AbadonedQuestId = uid
	if (beql.db.profile.QuestLog.chat.abandoned) then
		beql:Party_Status2Chat(L['Quest abandoned: '] .. tostring(name))
	end
end


function beql:Quixote_Objective_Update(title, uid, objective, had, numGot, numNeeded, qtype)
	local id = select(2, beqlQ:GetQuestByUid(uid))

	-- add unwatched quest
	if (beql.db.profile.QuestTracker.AddUntracked == true and (not IsQuestWatched(id))) then
		AddQuestWatch(id)
	end

	-- print progress to party
	if (beql.db.profile.QuestLog.chat.AnnounceQuest) then
		local objText

		if (qtype == "item" or qtype == "monster" or qtype == "reputation") then
			objText = objective..": "..numGot.."/"..numNeeded
		end
        --		text = description..objText
		if (beql.db.profile.QuestLog.chat.progress and objText) then
			beql:Party_Status2Chat(objText)
		end

		if (beql.db.profile.QuestLog.chat.finished and select(7, beqlQ:GetQuestByUid(uid)) == 1) then
			beql:Party_Status2Chat(title .." "..L["Completed!"])
		end
	end
end

function beql:Quixote_Quest_Complete(questname, uid)
	if (beql.db.profile.QuestLog.InfoOnQuestCompletion) then
		UIErrorsFrame:AddMessage(questname.." "..L["Completed!"], 1.0, 0.8, 0.0, 1.0, UIERRORS_HOLD_TIME)
		if (beql.db.profile.QuestLog.InfoSound and beql.db.profile.QuestLog.InfoSound ~= "") then
			PlaySoundFile(beql.db.profile.QuestLog.InfoSound)
		end
	end
end

function beql:Party_Status2Chat(msg)
	if (beql.db.profile.QuestLog.chat.AnnounceQuest) then
		if (beql.db.profile.QuestLog.chat.chattype == "default") then
			if (UnitInBattleground("player")) then
				SendChatMessage(msg, "BATTLEGROUND")
			elseif (GetRealNumRaidMembers() > 0) then
				SendChatMessage(msg, "RAID")
			elseif (GetRealNumPartyMembers() > 0) then
				SendChatMessage(msg, "PARTY")
			end
		elseif (beql.db.profile.QuestLog.chat.chattype == "group" and GetRealNumPartyMembers() > 0) then
			SendChatMessage(msg, "PARTY")
		elseif (beql.db.profile.QuestLog.chat.chattype == "say") then
			SendChatMessage(msg, "SAY")
		end
	end
	--questlog.chat.chattype
	if (beql.db.profile.debug and not msg or msg == "") then
		assert(false , "beql:Party_Status2Chat: massage is a '" .. tostring(msg) .. "' value")
	end
end

--[[----------------------------------------
-- Arguments:
-- number - quest id
-- string - quest name
--
-- Notes:
-- Prints the Quest Name/Status and Objectives to the currently opened chatbox
--
-- Returns:
-- * nothing
------------------------------------------]]
function beql:AddQuestStatusToChatFrame(questIndex)
	local chatFrame = DEFAULT_CHAT_FRAME
	local chatType = chatFrame.editBox:GetAttribute("chatType")
	local oText, oType, oNumP, oNumN, oComp
	local text
	if (chatType == "WHISPER") then
		chatType = "SAY"
	end
	local qID, qIndex , qTitle, qLvl, qTag, qObj, qStat, qRec, qdaily, qZone = beqlQ:GetQuestById(questIndex)
	if (qObj and qObj > 0) then
		SendChatMessage("["..qLvl..string.upper(beqlQ:GetShortTagForQuest(qID)).."] "..qTitle, chatType)
		local _, qObjectives = beqlQ:IterateObjectivesForQuest(qID)
		for oText, oItems in pairs(qObjectives) do
			text = ""
			oComp = false;
			oNumP, oNumN, oType = unpack(oItems)
			if (oNumN == nil) then
                oNumN = 1
            end
			if (oNumP == nil) then
                oNumP = 1
            end
			if (oText == nil) then
                oText = "" end
			if (oNumP == oNumN) then
				oComp = true
			end

			text = oText

			if (oComp) then
				text = text.." "..L["(Done)"]
			else
				text = text..": "..oNumP.."/"..oNumN
			end
			if (text and strlen(text) > 0) then
				SendChatMessage(" - "..text, chatType)
			end
		end

        --[[		for i=1, qObj do
        text = ""
        oText, oType, oNumP, oNumN, oComp = beqlQ:GetQuestStatusById(questIndex, i)
        text = oText
        if (finished) then
        text = text.." "..L["(Done)"]
        else
        text = text..": "..oNumP.."/"..oNumN
        end
        if (text and strlen(text) > 0) then
        SendChatMessage(" - "..text, chatType)
        end
		end--]]
	else
		chatFrame:AddMessage(L["No Objectives!"])
	end
	chatFrame.editBox:Hide()
end
